FZU 2105-Digits Count(线段树延时标记)

题意:

每次操作区间每个数进行一种(&或|、或^ )给定的一个数,到sum时统计给定区间的和。

分析:

这个题让我觉得我的思维很不活跃,对懒惰标记理解,还远远不够,通过这道题我对懒惰标记加深了不少。

经过各种操作和区间会变成相同数都相邻的情况,若在操作会变成另一个相同数。

选区间内相同数字为懒惰标记进行更新。

#include <map>
#include <set>
#include <list>
#include <cmath>
#include <queue>
#include <stack>
#include <cstdio>
#include <vector>
#include <string>
#include <cctype>
#include <complex>
#include <cassert>
#include <utility>
#include <cstring>
#include <cstdlib>
#include <iostream>
#include <algorithm>
using namespace std;
typedef pair<int,int> PII;
typedef long long ll;
#define lson l,m,rt<<1
#define pi acos(-1.0)
#define rson m+1,r,rt<<1|1
#define All 1,N,1
#define N 1000100
#define read freopen("in.txt", "r", stdin)
const ll  INFll = 0x3f3f3f3f3f3f3f3fLL;
const int INF= 0x7ffffff;
const int mod =  1000000007;
int same[N*4],n,q,a[N];
void pushup(int rt){
    if(same[rt<<1]==same[rt<<1|1]&&same[rt<<1]!=-1){
        same[rt]=same[rt<<1];
    }
}
void pushdown(int rt){
    if(same[rt]!=-1){
        same[rt<<1]=same[rt<<1|1]=same[rt];
        same[rt]=-1;
    }
}
void build(int l,int r,int rt){
        same[rt]=-1;
        if(l==r){
            same[rt]=a[l];
            return;
        }
    int m=(l+r)>>1;
    build(lson);
    build(rson);
    pushup(rt);
}
void update(int op,int opn,int L,int R,int l,int r,int rt){
    if(L<=l&&R>=r&&same[rt]!=-1){
        if(op==0)
            same[rt]&=opn;
        else if(op==1)
            same[rt]|=opn;
        else
            same[rt]^=opn;
        return;
    }
    pushdown(rt);
    int m=(l+r)>>1;
    if(L<=m)update(op,opn,L,R,lson);
    if(R>m)update(op,opn,L,R,rson);
    pushup(rt);
}
int query(int L,int R,int l,int r,int rt){
    if(L<=l&&R>=r&&same[rt]!=-1){
        return (r-l+1)*same[rt];
    }
    pushdown(rt);
    int num=0;
    int m=(l+r)>>1;
    if(L<=m)num+=query(L,R,lson);
    if(R>m)num+=query(L,R,rson);
    pushup(rt);
    return num;
}
int main()
{
    int t;
    scanf("%d",&t);
    char ans[5];
    while(t--){
        scanf("%d%d",&n,&q);
        for(int i=1;i<=n;++i)
            scanf("%d",&a[i]);
        build(1,n,1);
        int x,y,p;
        while(q--){
        scanf("%s",ans);
        if(ans[0]==‘A‘){
            scanf("%d%d%d",&p,&x,&y);
            update(0,p,x+1,y+1,1,n,1);
        }
        else if(ans[0]==‘O‘){
            scanf("%d%d%d",&p,&x,&y);
            update(1,p,x+1,y+1,1,n,1);
        }
       else if(ans[0]==‘X‘){
            scanf("%d%d%d",&p,&x,&y);
            update(2,p,x+1,y+1,1,n,1);
        }
        else{
            scanf("%d%d",&x,&y);
            printf("%d\n",query(x+1,y+1,1,n,1));
        }
        }
    }
return 0;
}
时间: 2024-12-28 16:10:50

FZU 2105-Digits Count(线段树延时标记)的相关文章

fzu 2105 Digits Count 线段树

题目链接:http://acm.fzu.edu.cn/problem.php?pid=2105 题意: 给出一个数组A[0]-A[n-1],每个数最大是16.有4种操作: AND opn L R:L-R区间内的数都AND上opn这个数 OR opn L R:L-R区间内的数都OR上opn这个数 XOR opn L R:L-R区间内的数都XOR上opn这个数 SUM L R:求L-R区间内所有数的和. 0 <= opn <= 16 思路: 可以发现A[i]和opn最大都不超过16,所以可以设4个

ACM: FZU 2105 Digits Count - 位运算的线段树【黑科技福利】

FZU 2105  Digits Count Time Limit:10000MS     Memory Limit:262144KB     64bit IO Format:%I64d & %I64u Practice Description Given N integers A={A[0],A[1],...,A[N-1]}. Here we have some operations: Operation 1: AND opn L R Here opn, L and R are integer

FZU 2105 Digits Count(按位维护线段树)

[题目链接] http://acm.fzu.edu.cn/problem.php?pid=2105 [题目大意] 给出一个序列,数字均小于16,为正数,每次区间操作可以使得 1. [l,r]区间and一个数 2. [l,r]区间or一个数 3. [l,r]区间xor一个数 4. [l,r]区间查询和 操作数均为小于16的非负整数 [题解] 由于操作数很小,因此我们可以按位维护四棵线段树,表示二进制中的第i位, 对于and操作,只有当and的当前位为0时才对区间有影响,效果是将区间全部变为0, 对

FZU 2105 Digits Count(位数计算)

Description 题目描述 Given N integers A={A[0],A[1],...,A[N-1]}. Here we have some operations: Operation 1: AND opn L R Here opn, L and R are integers. For L≤i≤R, we do A[i]=A[i] AND opn (here "AND" is bitwise operation). Operation 2: OR opn L R Here

fzu 2171 线段树 lazy标记

http://acm.fzu.edu.cn/problem.php?pid=2171      Problem 2171 防守阵地 II Accept: 73    Submit: 256Time Limit: 3000 mSec    Memory Limit : 32768 KB Problem Description 部队中总共有N个士兵,每个士兵有各自的能力指数Xi,在一次演练中,指挥部确定了M个需要防守的地点,指挥部将选择M个士兵依次进入指定地点进行防守任务,获得的参考指数即为M个士兵

FOJ 2105 Digits Count

题意:对一串数字进行抑或某数,和某数,或某数,统计某区间和的操作. 思路:因为化成二进制就4位可以建4颗线段树,每颗代表一位二进制. and 如果该为是1  直接无视,是0则成段赋值为0: or  如果是0 无视,是1则成段赋值为1: xor 成段亦或,1个数和0个数交换: sum 求和: #include<cstdio> #include<cstring> #include<algorithm> #include<vector> #include <

线段树lazy标记??Hdu4902

Nice boat Time Limit: 30000/15000 MS (Java/Others)    Memory Limit: 131072/131072 K (Java/Others) Total Submission(s): 335    Accepted Submission(s): 159 Problem Description There is an old country and the king fell in love with a devil. The devil al

POJ 3468 线段树+lazy标记

lazy标记 Time Limit:5000MS     Memory Limit:131072KB     64bit IO Format:%I64d & %I64u Submit Status Description You have N integers, A1, A2, ... , AN. You need to deal with two kinds of operations. One type of operation is to add some given number to

HDU 1698 Just a Hook (线段树延迟标记(lazy))

题意:有n个数初始值都为1,m个操作a,b,c,表示把区间[a,b]变为c,求最后n个数的和. 经典区间更新求和问题,需要用到延迟标记(或者说是懒惰标记),简单老说就是每次更新 的时候不要更新到底,用延迟标记使得更新延迟到下次需要更新或询问的时候. #include<cstdio> #include<stdlib.h> #include<string.h> #include<string> #include<map> #include<cm